/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id: rlomenu.js,v 1.1.2.1 2015/06/22 09:27:09 rakollep Exp $ */
 
MenuController =
{
	countObject : "group",
	init : function()
	{
		var e = parent.ViewerController.events;

		e.navigate.subscribe(this.handleNavigation,this,true);
		e.load.subscribe(this.updateButtons,this,true);
		e.score.subscribe(this.updateButtons,this,true);
	},
	handleNavigation : function(type,args)
	{
		this.updateCounter();
		this.updateButtons();
		this.updateTitles(args[0]);
	},
	updateCounter : function()
	{
		var yd = YAHOO.util.Dom;
		var elm = yd.get('TopicCount');
		if (elm != null)
		{
			var types = (MenuController.countObject == "group") ? [11,6,7,13] : [2,6,7,13];

			var p = parent.ViewerController.getPosition(types);
			if (p.position > -1)
			{
				if (yd.getStyle(document.body,"direction") == "ltr")
				{
					elm.innerHTML = (p.position+1)+" "+this.ofText+" "+p.total;
				}
				else
				{
					// reverse the order for RTL
					elm.innerHTML = "<span dir=\"ltr\">"+p.total+"</span> "+this.ofText+" <span dir=\"ltr\">"+(p.position+1)+"</span>";
				}
			}
		}
	},
	updateButtons : function()
	{
		var vc = parent.ViewerController;

		this.updateButton("PrevBtn",vc.previous(true),{imgId:"PrevImg",enabled:"Prevoff",disabled:"Prevdis"});
		this.updateButton("NextBtn",vc.next(true),{imgId:"NextImg",enabled:"Nextoff",disabled:"Nextdis"});
		this.updateButton("PrevLOBtn",vc.previousLO(true),{imgId:"PrevLOImg",enabled:"PrevLOoff",disabled:"PrevLOdis"});
		this.updateButton("NextLOBtn",vc.nextLO(true),{imgId:"NextLOImg",enabled:"NextLOoff",disabled:"NextLOdis"});
	},
	updateTitles : function(obj)
	{
		var yd = YAHOO.util.Dom;
		var elm = yd.get("loName");
		if (elm != null)
		{
			var pMap = {};
			var p = obj;
			while ((p = p.parent) != null)
			{
				pMap[p.type] = p;
			}
			
			if (pMap[3])
			{
				elm.innerHTML = pMap[3].label;
			}
			else if (obj.parent && (obj.parent.type == 4))
			{
				elm.innerHTML = obj.label;
			}
			else
			{
				elm.innerHTML = "";
			}
		}
	},
	updateButton : function(btnObj, state, cfg)
	{
		if (window[btnObj])
		{
			window[btnObj].disabled = !state;
			var elm = document.getElementById(cfg.imgId);
			if (elm)
			{
				var yd = YAHOO.util.Dom;

				if (state)
				{
					elm.src = window[cfg.enabled].src;
					yd.replaceClass(elm,"buttonOff","buttonOn");
				}
				else
				{
					elm.src = window[cfg.disabled].src;
					yd.replaceClass(elm,"buttonOn","buttonOff");
				}
			}
		}
	},
	flipImage : function(layer,imgName,imgObj)
	{
		document.images[imgName].src = window[imgObj].src;
	},
	toolbarButtonClickHandler : function(id,btnRef)
	{
		var r = false;
		if (!btnRef.disabled) 
		{
			btnRef.click();
			r = true;
		}
		return r;
	}
}

PrevLOBtn = 
{
	click : function()
	{
		parent.ViewerController.previousLO();
	}
}

NextLOBtn = 
{
	click : function()
	{
		parent.ViewerController.nextLO();
	}
}

NextBtn = 
{
	click : function()
	{
		parent.ViewerController.next();
	}
}

PrevBtn = 
{
	click : function()
	{
		parent.ViewerController.previous();
	}
}

GenPDABtn =
{
	click : function()
	{
		parent.ViewerController.generateToPDA();
	}
}

DiscussionBtn = 
{
	click : function()
	{
		parent.ViewerController.openDiscussion();
	}
}

HomeBtn =
{
	click : function()
	{
		parent.OSDeliveryEngine.closeWindow();
    }
}

HelpBtn = 
{
	click : function()
	{
		parent.ViewerController.openHelp();
	}
}

GlossaryBtn = 
{
	click : function()
	{
		parent.ViewerController.openGlossary();
	}
}

ShowNavBtn = 
{
	restore : null,
	click : function()
	{
		var yd = parent.YAHOO.util.Dom;
		var elm = yd.get("botframe");
		if (elm != null)
		{
			if (!this.restore)
			{
				this.restore = elm.cols;
				elm.cols = "*, 100%";
			}
			else
			{
				elm.cols = this.restore;
				this.restore = null;
			}
		}
	}
}

CloseBtn = 
{
	click : function(e)
	{
		return HomeBtn.click(e);
	}
}